
SyncUI_UIScale = 768 / 1080
SyncUI_FontPath = [[Interface\AddOns\SyncUI\Media\Fonts\Vibro.ttf]]

BINDING_CATEGORY_SYNCUI = "|cFF00FF99Sync|cFFFFFFFFUI"
BINDING_HEADER_SyncPlayer = "Music Player"
BINDING_HEADER_SyncQuestHub = "Quest Hub"

SYNCUI_CLASS_COLORS = {
    ["HUNTER"] 		= { r = 0.5, g = 0.7, b = 0.2 },
    ["WARLOCK"] 	= { r = 0.6, g = 0.0, b = 1.0 },
    ["PRIEST"] 		= { r = 1.0, g = 1.0, b = 1.0 },
    ["PALADIN"] 	= { r = 1.0, g = 0.2, b = 0.8 },
    ["MAGE"] 		= { r = 0.0, g = 0.8, b = 1.0 },
    ["ROGUE"]		= { r = 1.0, g = 1.0, b = 0.0 },
    ["DRUID"] 		= { r = 1.0, g = 0.3, b = 0.0 },
    ["SHAMAN"] 		= { r = 0.0, g = 0.4, b = 1.0 },
    ["WARRIOR"] 	= { r = 0.8, g = 0.6, b = 0.4 },
    ["DEATHKNIGHT"] = { r = 0.9, g = 0.0, b = 0.2 },
    ["MONK"] 		= { r = 0.0, g = 1.0, b = 0.6 },
}

SYNCUI_POWER_COLORS = {
	["MANA"] 		= { r = 0.0, g = 0.4, b = 8.0},
	["RAGE"] 		= { r = 1.0, g = 0.2, b = 0.2},
	["FOCUS"] 		= { r = 0.8, g = 0.4, b = 0.0},
	["ENERGY"] 		= { r = 0.8, g = 0.8, b = 0.0},
	["RUNIC_POWER"] = { r = 0.0, g = 0.8, b = 1.0},
}

SYNCUI_FONTLIST = {
	{"Nexa.otf",8,10,12,14,16},
	{"Haas.ttf",8,10,12,14,16},
	{"Prototype.ttf",8,10,12,14,16},
	{"Vibro.ttf",7,8,10,12,14},
	{"Zero.ttf",7,8,10,12,14},
	{"Chivo.otf",8,10,12,14,16},
	{"Days.otf",7,8,10,12,14},
	-- Cyrillic
	{"Exo.otf",8,10,12,14,16,"Cyrillic"},
	{"Roboto.ttf",8,10,12,14,16,"Cyrillic"},
}

SYNCUI_PETICONS = {
	["Basilisk"] = "Interface\\Icons\\Ability_Hunter_Pet_Crocolisk",
	["Bat"] = "Interface\\Icons\\Ability_Hunter_Pet_bat",
	["Bear"] = "Interface\\Icons\\ability_hunter_pet_bear",
	["Beetle"] = "Interface\\Icons\\inv_misc_ahnqirajtrinket_01",
	["Bird of Prey"] = "Interface\\Icons\\ability_hunter_pet_owl",
	["Boar"] = "Interface\\Icons\\ability_hunter_pet_boar",
	["Carrion Bird"] = "Interface\\Icons\\ability_hunter_pet_vulture",
	["Cat"] = "Interface\\Icons\\ability_hunter_pet_cat",
	["Chimaera"] = "Interface\\Icons\\ability_hunter_pet_chimera",
	["Core Hound"] = "Interface\\Icons\\ability_hunter_pet_corehound",
	["Crab"] = "Interface\\Icons\\ability_hunter_pet_crab",
	["Crane"] = "Interface\\Icons\\ability_mount_cranemountblue",
	["Crocolisk"] = "Interface\\Icons\\Ability_Hunter_Pet_Crocolisk",
	["Devilsaur"] = "Interface\\Icons\\ability_hunter_pet_devilsaur",
	["Direhorn"] = "Interface\\Icons\\ability_mount_triceratopsmount",
	["Dog"] = "Interface\\Icons\\inv_jewelry_necklace_22",
	["Dragonhawk"] = "Interface\\Icons\\ability_hunter_pet_dragonhawk",
	["Fox"] = "Interface\\Icons\\ability_hunter_aspectofthefox",
	["Goat"] = "Interface\\Icons\\ability_mount_mountainram",
	["Gorilla"] = "Interface\\Icons\\ability_hunter_pet_gorilla",
	["Hyena"] = "Interface\\Icons\\ability_hunter_pet_hyena",
	["Monkey"] = "Interface\\Icons\\ability_hunter_aspectofthemonkey",
	["Moth"] = "Interface\\Icons\\ability_hunter_pet_moth",
	["Nether Ray"] = "Interface\\Icons\\ability_hunter_pet_netherray",
	["Porcupine"] = "Interface\\Icons\\inv_pet_porcupine",
	["Quilen"] = "Interface\\Icons\\achievement_moguraid_01",
	["Raptor"] = "Interface\\Icons\\ability_hunter_pet_raptor",
	["Ravager"] = "Interface\\Icons\\ability_hunter_pet_ravager",
	["Rhino"] = "Interface\\Icons\\ability_hunter_pet_rhino",
	["Scorpid"] = "Interface\\Icons\\ability_hunter_pet_scorpid",
	["Serpent"] = "Interface\\Icons\\spell_nature_guardianward",
	["Shale Spider"] = "Interface\\Icons\\ability_hunter_pet_spider",
	["Silithid"] = "Interface\\Icons\\ability_hunter_pet_silithid",
	["Spider"] = "Interface\\Icons\\ability_hunter_pet_spider",
	["Spirit Beast"] = "Interface\\Icons\\ability_druid_primalprecision",
	["Sporebat"] = "Interface\\Icons\\ability_hunter_pet_sporebat",
	["Tallstrider"] = "Interface\\Icons\\ability_hunter_pet_tallstrider",
	["Turtle"] = "Interface\\Icons\\ability_hunter_pet_turtle",
	["Warp Stalker"] = "Interface\\Icons\\ability_hunter_pet_warpstalker",
	["Wasp"] = "Interface\\Icons\\ability_hunter_pet_wasp",
	["Water Strider"] = "Interface\\Icons\\inv_pet_waterstrider",
	["Wind Serpent"] = "Interface\\Icons\\ability_hunter_pet_windserpent",
	["Wolf"] = "Interface\\Icons\\ability_hunter_pet_wolf",
	["Worm"] = "Interface\\Icons\\ability_hunter_pet_worm",

	["Ghoul"] = "Interface\\Icons\\spell_deathknight_armyofthedead",
	["Water Elemental"] = "Interface\\Icons\\spell_frost_summonwaterelemental_2",
	["Felguard"] = "Interface\\Icons\\spell_shadow_summonfelguard",
	["Felhunter"] = "Interface\\Icons\\spell_shadow_summonfelhunter",
	["Fel Imp"] = "Interface\\Icons\\spell_warlock_summonimpoutland",
	["Imp"] = "Interface\\Icons\\spell_shadow_summonimp",
	["Observer"] = "Interface\\Icons\\warlock_summon_ beholder",
	["Shivarra"] = "Interface\\Icons\\warlock_summon_ shivan",
	["Succubus"] = "Interface\\Icons\\spell_shadow_summonsuccubus",
	["Voidlord"] = "Interface\\Icons\\warlock_summon_ voidlord",
	["Voidwalker"] = "Interface\\Icons\\spell_shadow_summonvoidwalker",
	["Wrathguard"] = "Interface\\Icons\\spell_warlock_summonwrathguard",
}


local resScales = {
	-- 16:10
	["1280x800"] = 0.9,
	["1440x900"] = 0.9,
	["1680x1050"] = 0.9,
	["1920x1200"] = 0.9,
	["2560x1600"] = 0.9,
}

function SyncUI_UIParent_OnLoad(self)
	UIParent:HookScript("OnShow", function() self:SetAlpha(1) end)
	UIParent:HookScript("OnHide", function() self:SetAlpha(0) end)

	MovieFrame:SetScript("OnEvent", function(self,event,...)
		if SyncUI_Data.Options.SkipCinematics then
			GameMovieFinished()
		elseif event == "PLAY_MOVIE" then
			local movieID = ...
			if movieID then
				MovieFrame_PlayMovie(self, movieID)
			end
		end
	end)
	hooksecurefunc(CinematicFrame,"Show", function()
		if SyncUI_Data.Options.SkipCinematics then
			CinematicFrame.closeDialog:Hide()
			CinematicFrame_CancelCinematic()
		end
	end)

	
	do	-- fix Aspect Ratio Scaling
		local index = GetCurrentResolution()
		local curRes = select(index, GetScreenResolutions())
		
		for res, scaling in pairs(resScales) do
			if res == curRes then
				self:SetScale(scaling)
				
				print("Scale has been adjusted to: "..scaling)
				break
			end
		end
	end
end

function SyncUI_DisableFrame(ref,ignore)
	local frame
	
	if type(ref) == "string" then
		frame = _G[ref]
	else
		frame = ref
	end
	
	if frame then
		frame:SetParent(SyncUI_DisableBlizzard)
		
		if not ignore then
			frame:UnregisterAllEvents()
		end
	end
end

function SyncUI_Flashing_OnInit(self,fadeInTime,fadeOutTime,flashDuration)
    self.fadeInTime = fadeInTime
    self.fadeOutTime = fadeOutTime
    self.flashDuration = flashDuration
    self.flashTimer = 0
end

function SyncUI_Flashing_OnUpdate(self,elapsed)
	self.flashTimer = self.flashTimer + elapsed

	if self.flashTimer > self.flashDuration and self.flashDuration ~= -1 then
		-- do nothing
	else
		local flashTime = self.flashTimer
		local alpha

		flashTime = flashTime%(self.fadeInTime + self.fadeOutTime)
		if flashTime < self.fadeInTime then
			alpha = flashTime/self.fadeInTime
		elseif flashTime < self.fadeInTime then
			alpha = 1
		elseif flashTime < self.fadeInTime + self.fadeOutTime then
			alpha = 1 - ((flashTime - self.fadeInTime) / self.fadeOutTime)
		else
			alpha = 0
		end

		self:SetAlpha(alpha)
	end
end

function SyncUI_SlideIn(self)
	self.SlideIn:Play()
end

function SyncUI_SlideOut(self)
	self.SlideOut:Play()
end

function SyncUI_Cooldown_OnRegister(self)
	local numRegions = self:GetNumRegions()

	for i = 1, numRegions do
		local region = select(i, self:GetRegions())
		local height = self:GetHeight()
		
		if region.GetText then
			if height > 37 then
				region:SetFontObject(SyncUI_GameFontNormal_Huge)
			elseif height > 25 then
				region:SetFontObject(SyncUI_GameFontNormal_Large)
			else
				region:SetFontObject(SyncUI_GameFontNormal_Small)
			end
			
			region:SetPoint("CENTER",1,0)
		end 
	end

	self:SetBlingTexture("")
end

function SyncUI_RoundNumber(num, idp)
	return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

function SyncUI_GetNumberFormat(value)
	local valueString = value
  
	while true do  
		valueString, k = string.gsub(valueString, "^(-?%d+)(%d%d%d)", "%1.%2")

		if k == 0 then
			break
		end
	end
	
	return valueString
end

function SyncUI_GetTableEntry(tbl,entry)
	for _, value in pairs(tbl) do
		if value == entry then
			return true
		end
	end
	
	return
end

function SyncUI_GetItemUpgradeLevel(itemLink)
	if not itemLink or not GetItemInfo(itemLink) then
		return
	end
	
	SyncTooltip:SetOwner(UIParent, "ANCHOR_NONE")
	SyncTooltip:SetHyperlink(itemLink)
	
	for i = 2, SyncTooltip:NumLines() do
		local text = _G["SyncTooltipTextLeft"..i]:GetText()
		local UPGRADE_LEVEL = gsub(ITEM_LEVEL," %d","")
		
		if text and text:find(UPGRADE_LEVEL) then
			local itemLevel = string.match(text,"%d+")

			if itemLevel then
				return tonumber(itemLevel)
			end
		end
	end
end


local EffectiveLevelColors = {
	["Impossible"]	= {1.0,0.0,0.0},
	["Hard"]		= {1.0,0.3,0.0},
	["Normal"]		= {1.0,1.0,1.0},
	["Easy"]		= {0.0,1.0,0.0},
	["Trivial"]		= {0.5,0.5,0.5},
}

function SyncUI_GetEffectiveLevelColor(unitLvl)
	local playerLvl = UnitLevel("player")
	local stage = unitLvl - playerLvl
	local color;
	
	if stage >= 5 then
		color = EffectiveLevelColors["Impossible"]
	elseif stage >= 3 then
		color = EffectiveLevelColors["Hard"]
	elseif stage >= -4 then
		color = EffectiveLevelColors["Normal"]
	elseif -stage <= GetQuestGreenRange() then
		color = EffectiveLevelColors["Easy"]
	else
		color = EffectiveLevelColors["Trivial"]
	end
	
	return unpack(color)
end

function SyncUI_GetColorizedText(string,r,g,b)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return "|cFF"..string.format("%02x%02x%02x", r*255, g*255, b*255)..string.."|r"
end


local function decrypt(code)
	local string = ""
	
	for i in code:gmatch"[A-Za-z0-9][A-Za-z0-9]" do
		string = string..string.char("0x"..i)
	end
	
	return string
end

function SyncUI_IsDev()
	local info = select(2, BNGetInfo())
	local code = decrypt("53796e63726f772332353239")

	if info and info == code then
		return true
	end
	
	return
end

